Bug 1728307 - Review Request: foundation-icons-fonts - Icons web font
Summary: Review Request: foundation-icons-fonts - Icons web font
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Robert-André Mauchin
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2019-07-09 15:32 UTC by Xavier Bachelot
Modified: 2019-08-08 03:01 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2019-08-03 01:16:48 UTC
zebob.m: fedora-review+


Attachments (Terms of Use)

Description Xavier Bachelot 2019-07-09 15:32:27 UTC
Spec URL: https://www.bachelot.org/fedora/SPECS/foundation-icons-fonts.spec
SRPM URL: https://www.bachelot.org/fedora/SRPMS/foundation-icons-fonts-3.0-1.fc31.src.rpm
Description: A custom collection of 283 icons that are stored in a handy web font.
Fedora Account System Username: xavierb

Comment 1 Robert-André Mauchin 2019-07-13 15:18:16 UTC
 - Own this dir:

[!]: Package requires other packages for directories it uses.
     Note: No known owner of /usr/share/fonts/foundation-icons

 - Escape the macros in comment


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated". 291 files have unknown license.
     Detailed output of licensecheck in
     /home/bob/packaging/review/foundation-icons-fonts/review-foundation-
     icons-fonts/licensecheck.txt
[!]: Package requires other packages for directories it uses.
     Note: No known owner of /usr/share/fonts/foundation-icons
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 0 bytes in 0 files.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.



Rpmlint
-------
Checking: foundation-icons-fonts-web-3.0-1.fc31.noarch.rpm
          foundation-icons-fonts-3.0-1.fc31.src.rpm
foundation-icons-fonts-web.noarch: W: no-documentation
foundation-icons-fonts.src:13: W: macro-in-comment %{fontname}
foundation-icons-fonts.src:62: W: macro-in-comment %{SOURCE2}
foundation-icons-fonts.src:63: W: macro-in-comment %{buildroot}
foundation-icons-fonts.src:63: W: macro-in-comment %{_datadir}
foundation-icons-fonts.src:63: W: macro-in-comment %{fontname}
foundation-icons-fonts.src:67: W: macro-in-comment %{buildroot}
foundation-icons-fonts.src:67: W: macro-in-comment %{_datadir}
foundation-icons-fonts.src:67: W: macro-in-comment %{fontname}
foundation-icons-fonts.src:70: W: macro-in-comment %{fontname}
foundation-icons-fonts.src: E: specfile-error warning: Macro expanded in comment on line 13: %{fontname}.metainfo.xml
foundation-icons-fonts.src: E: specfile-error 
foundation-icons-fonts.src: E: specfile-error warning: Macro expanded in comment on line 13: %{fontname}.metainfo.xml
2 packages and 0 specfiles checked; 3 errors, 10 warnings.

Comment 2 Nicolas Mailhot 2019-07-14 10:31:11 UTC
BTW, this part seems to have been lost in the adoc convertion of the wiki

https://fedoraproject.org/wiki/Choosing_the_right_font_format_to_package

And, the situation improved since 2009, 
https://caniuse.com/#feat=ttf

So the revised fonts pacakging guidelines I'm finishing up with
https://copr.fedorainfracloud.org/coprs/nim/fonts-rpm-macros/

will just forbid packaging anything except opentype, with console fonts as the only exception

(none of the cargo-culted web font formats that have been useless for years and serve as a form of DRM, no PS1 fonts that even LibreOffice refuses to read nowadays, etc)

And I need to figure how to rescue ttname that somone added to the guidelines, since it seems to be a casualty of python3

Comment 3 Nicolas Mailhot 2019-07-14 10:33:53 UTC
(most web font formats are legact garbage, and woff is sequivalent to opentype, except it's not supported in apps, so it's a form of drm for proprietary fonts. We don't allow those in Fedora, just use opentype everywhere)

Comment 4 Xavier Bachelot 2019-07-17 13:23:47 UTC
Thanks for the review Robert-André.

And thanks for the comments Nicolas. As this is my very first font package and I know next to nothing about fonts in general, please bear with me for any stupid question :-)

So, practically speaking, I should only package the ttf font and remove all of the others (eot, woff and svg).

And then I should patch the css file to remove references to eot, woff and svg.

The css currently contains this :
"""
@font-face {
  font-family: "foundation-icons";
  src: url("foundation-icons.eot");
  src: url("foundation-icons.eot?#iefix") format("embedded-opentype"),
       url("foundation-icons.woff") format("woff"),
       url("foundation-icons.ttf") format("truetype"),
       url("foundation-icons.svg#fontcustom") format("svg");
  font-weight: normal;
  font-style: normal;
}
"""

It should be rewritten to :
"""
@font-face {
  font-family: "foundation-icons";
  src: url("foundation-icons.ttf") format("truetype");
  font-weight: normal;
  font-style: normal;
}
"""

Is that correct ?

Then, as I'm packaging this font to unbundle it from another software that just passed review (sympa mailing list manager, RHBZ#17283000), I shall convince upstream to only keep the ttf version of the font and assure them this will not break the WUI for any browser. Do you have any link to support this claim ? Or shall https://caniuse.com/#feat=ttf be enough ?

Comment 5 Nicolas Mailhot 2019-07-17 14:57:05 UTC
It is not a stupid question, the font situation is a mess because everyone thinks it is simple, no one makes an effort to do things cleanly, and as a result fixing things falls on packagers.

Yes, you can just remove all the other formats, and keep only the opentype file (just check in a browser in case you made a typo somewhere)

As far as I know, caniuse is the reference to check if a feature is supported in browsers. It's a thankless inventory task no one else wants to do.

Comment 6 Nicolas Mailhot 2019-07-17 15:05:04 UTC
BTW, if you're curious the project files are here

https://pagure.io/fork/nim/packaging-committee/commits/fonts-rpm-macros
https://pagure.io/fork/nim/fonts-rpm-macros
https://copr.fedorainfracloud.org/coprs/nim/fonts-rpm-macros/builds/
https://copr.fedorainfracloud.org/coprs/nim/fonts-rpm-macros-noreg/builds/

There are large stretches of no activity in git, when I priorised Go SIG work over Fonts SIG work, even though both use the same macro routines and design

Comment 7 Xavier Bachelot 2019-07-17 17:09:42 UTC
Thanks for the explanations Nicolas.

Here's an updated version :
Spec URL: https://www.bachelot.org/fedora/SPECS/foundation-icons-fonts.spec
SRPM URL: https://www.bachelot.org/fedora/SRPMS/foundation-icons-fonts-3.0-2.fc31.src.rpm

Changelog:
* Wed Jul 17 2019 Xavier Bachelot <xavier@bachelot.org> - 3.0-2
- Package TTF font only and add patch to fix CSS accordingly.
- Update descriptions and summaries.
- Drop commented out appstream support.

Comment 8 Robert-André Mauchin 2019-07-17 17:16:33 UTC
LGTM, package approved.

Comment 9 Nicolas Mailhot 2019-07-17 17:25:41 UTC
(In reply to Xavier Bachelot from comment #7)

> - Drop commented out appstream support.

Sorry about that, not wasting time on manual appstream files is perfectly fine, they don't contain any info not already present in the rpm package, so the next generation of font macros will just generate them (as it should have been done in the first place)

I really need to finish this and send it to FPC :(

Comment 10 Xavier Bachelot 2019-07-18 08:33:21 UTC
(In reply to Robert-André Mauchin from comment #8)
> LGTM, package approved.

Thanks for the review.

(In reply to Nicolas Mailhot from comment #9)
> (In reply to Xavier Bachelot from comment #7)
> 
> > - Drop commented out appstream support.
> 
> Sorry about that, not wasting time on manual appstream files is perfectly
> fine, they don't contain any info not already present in the rpm package, so
> the next generation of font macros will just generate them (as it should
> have been done in the first place)
> 
> I really need to finish this and send it to FPC :(

No worries, it was just a couple lines to remove, not a big deal and much easier than to grasp what the appstream support is all about. I'll save that for another time.
Thanks for your help.

Comment 11 Xavier Bachelot 2019-07-18 08:37:08 UTC
Crap, I reset the fedora-review flag :-(
Robert-André, can you please fix my mistake ? Sorry about that...

Comment 12 Mohan Boddu 2019-07-19 16:20:00 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/foundation-icons-fonts

Comment 13 Fedora Update System 2019-07-19 22:07:09 UTC
FEDORA-2019-1fa6d7715d has been submitted as an update to Fedora 30. https://bodhi.fedoraproject.org/updates/FEDORA-2019-1fa6d7715d

Comment 14 Fedora Update System 2019-07-19 22:07:12 UTC
FEDORA-2019-e32fb9f542 has been submitted as an update to Fedora 29. https://bodhi.fedoraproject.org/updates/FEDORA-2019-e32fb9f542

Comment 15 Fedora Update System 2019-07-19 22:07:13 UTC
FEDORA-EPEL-2019-d3dc6e0576 has been submitted as an update to Fedora EPEL 6. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2019-d3dc6e0576

Comment 16 Fedora Update System 2019-07-20 01:00:11 UTC
foundation-icons-fonts-3.0-2.fc30 has been pushed to the Fedora 30 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2019-1fa6d7715d

Comment 17 Fedora Update System 2019-07-20 03:42:01 UTC
foundation-icons-fonts-3.0-2.fc29 has been pushed to the Fedora 29 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2019-e32fb9f542

Comment 18 Fedora Update System 2019-07-20 03:48:13 UTC
foundation-icons-fonts-3.0-2.el7 has been pushed to the Fedora EPEL 7 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2019-be2bbc2b75

Comment 19 Fedora Update System 2019-07-20 19:33:08 UTC
foundation-icons-fonts-3.0-2.el6 has been pushed to the Fedora EPEL 6 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2019-d3dc6e0576

Comment 20 Fedora Update System 2019-08-03 01:16:48 UTC
foundation-icons-fonts-3.0-2.fc30 has been pushed to the Fedora 30 stable repository. If problems still persist, please make note of it in this bug report.

Comment 21 Fedora Update System 2019-08-03 04:06:07 UTC
foundation-icons-fonts-3.0-2.fc29 has been pushed to the Fedora 29 stable repository. If problems still persist, please make note of it in this bug report.

Comment 22 Fedora Update System 2019-08-08 00:34:10 UTC
foundation-icons-fonts-3.0-2.el7 has been pushed to the Fedora EPEL 7 stable repository. If problems still persist, please make note of it in this bug report.

Comment 23 Fedora Update System 2019-08-08 03:01:55 UTC
foundation-icons-fonts-3.0-2.el6 has been pushed to the Fedora EPEL 6 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.